unit Sort2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, MathEdit, ExtCtrls;

const max = 10000;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    BtnFill: TButton;
    BtnSort: TButton;
    BtnExit: TButton;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    IEd_swCount: TIntEdit;
    IEd_compCount: TIntEdit;
    Label2: TLabel;
    IEd_Len: TIntEdit;
    Label3: TLabel;
    procedure BtnExitClick(Sender: TObject);
    procedure BtnFillClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnSortClick(Sender: TObject);
    procedure IEd_LenExit(Sender: TObject);
  private
    { Private-Deklarationen }
    maxi      : Integer;
    tab       : Array [0..max] of Integer;
    procedure FillTab;
    procedure ShowTab;
    function  IsLessThan(a, b : Integer): Boolean;
    procedure Exchange(var i1, i2: Integer);
    procedure SortTab;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{============ Mathematische Hilfs-Prozeduren =============================}

procedure TForm1.FillTab;
  var i : Integer;
  begin
  Randomize;
  For i := 0 to Pred(maxi) do
     tab[i] := Random(2*maxi);
  IEd_swCount.Value   := 0;
  IEd_compCount.Value := 0;
  end;

procedure TForm1.ShowTab;
  var i : Integer;
  begin
  For i := 0 to Pred(maxi) do begin
    StringGrid1.Cells[i, 0] := IntToStr(i);
    StringGrid1.Cells[i, 1] := IntToStr(tab[i]);
    end;
  end;

function TForm1.IsLessThan(a, b : Integer): Boolean;
  begin
  Result := a < b;
  IEd_compCount.Value := IEd_compCount.Value + 1;
  end;

procedure TForm1.Exchange(var i1, i2 : Integer);
  var p : Integer;
  begin
  p  := i1;
  i1 := i2;
  i2 := p;
  IEd_swCount.Value := IEd_swCount.Value + 1;
  end;

procedure TForm1.SortTab;

  procedure AustauschSort;
    var i, k : Integer;
    begin
    For i := 0 to Pred(maxi) - 1 do
      For k := i + 1 to Pred(maxi) do
        If IsLessThan(tab[k], tab[i]) then
          Exchange(tab[i], tab[k]);
    end;

  procedure BubbleSort;
    var i, k : Integer;
    begin
    For i := 0 to Pred(maxi) - 1 do
      For k := Pred(maxi) downto i + 1 do
        If IsLessThan(tab[k], tab[i]) then
          Exchange(tab[i], tab[k]);
    end;

  procedure AuswahlSort;
    var i, k, m: Integer;
    begin
    For k := 0 to Pred(maxi) - 1 do begin
      m := k;
      For i := k + 1 to Pred(maxi) do
        If IsLessThan(tab[i], tab[m]) then
          m := i;
      If m <> k then
        Exchange(tab[m], tab[k]);
      end;
    end;

  procedure QuickSort;

    procedure qs(li, re: Integer);
      var i, j, v : Integer;
      begin
      i := li; j := re;
      v := tab[(li+re) Div 2];
      Repeat
        While IsLessThan(tab[i], v) do i := i + 1;
        While IsLessThan(v, tab[j]) do j := j - 1;
        If i <= j then begin
          Exchange(tab[i], tab[j]);
          i := i + 1;
          j := j - 1;
          end;
      until i > j;
      If li < j then qs(li, j);
      If i < re then qs(i, re);
      end;

    begin
    qs(0, Pred(maxi));
    end;

  begin
  IEd_swCount.Value := 0;
  IEd_compCount.Value := 0;
  Case RadioGroup1.ItemIndex of
    0: AustauschSort;
    1: BubbleSort;
    2: AuswahlSort;
    3: QuickSort;
  end; { of case }
  ShowTab;
  end;

{=============== Formular-Methoden ======================================}

procedure TForm1.FormCreate(Sender: TObject);
  begin
  maxi := 16;
  StringGrid1.ColCount := maxi;
  IEd_Len.Value        := maxi;
  BtnFillClick(Sender);
  end;

procedure TForm1.BtnFillClick(Sender: TObject);
  begin
  FillTab;
  ShowTab;
  StringGrid1.Update;
  end;

procedure TForm1.BtnSortClick(Sender: TObject);
  begin
  SortTab;
  ShowTab;
  end;

procedure TForm1.IEd_LenExit(Sender: TObject);
  begin
  maxi := IEd_Len.Value;
  If maxi > max then maxi := max;
  StringGrid1.ColCount := maxi;
  StringGrid1.Update;
  end;

procedure TForm1.BtnExitClick(Sender: TObject);
  begin
  Close;
  end;

end.
